///////////////////////// Includes ///////////////////////////////////////

#include "stdafx.h"
#include "GPSCom.h"
#include "GGASentence.h"


///////////////////////// Macros / Defines ///////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


///////////////////////// Implementation /////////////////////////////////

CGGASentence::CGGASentence() : m_nSatellites(0),
                               m_dblAltitude(0.0),
                               m_Fix(GPS_QUALITY_FIX_NOT_AVAILABLE)
{
}

STDMETHODIMP CGGASentence::get_Satellites(long* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_nSatellites;

	return S_OK;
}

STDMETHODIMP CGGASentence::get_Altitude(double* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_dblAltitude;

	return S_OK;
}

STDMETHODIMP CGGASentence::get_Fix(GPS_FIX* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_Fix;

	return S_OK;
}
