#pragma once

#ifndef __GPSCOMCP_H__
#define __GPSCOMCP_H__

//Pull in the new improved IConnectionPoint implementation which works across threads by using the GIT
#include "ATLCPImplMT.h"

template <class T>
class CProxy_IGPSConnectionEvents : public IConnectionPointImplMT<T, &DIID__IGPSConnectionEvents, _IGPSConnectionEvents>
{
public:
	HRESULT Fire_OnRMCSentence()
	{
	  //Serialize access to the clients array of IConnectionPointImplMT which is accessed via GetInterfaceAt
	  CComCritSecLock<CComAutoCriticalSection> lock(m_CPMTCritSec);
	
		CComVariant varResult;
		int nConnections = m_Clients.GetSize();
		for (int nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
      CComPtr<IDispatch> sp;
      sp.Attach(GetInterfaceAt(nConnectionIndex));
			if (sp)
			{
				VariantClear(&varResult);
				DISPPARAMS disp = { NULL, NULL, 0, 0 };
				sp->Invoke(0x1, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, &varResult, NULL, NULL);
			}
		}
		return varResult.scode;
	}

	HRESULT Fire_OnGGASentence()
	{
	  //Serialize access to the clients array of IConnectionPointImplMT which is accessed via GetInterfaceAt
	  CComCritSecLock<CComAutoCriticalSection> lock(m_CPMTCritSec);
	
		CComVariant varResult;
		int nConnections = m_Clients.GetSize();
		for (int nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
      CComPtr<IDispatch> sp;
      sp.Attach(GetInterfaceAt(nConnectionIndex));
			if (sp)
			{
				VariantClear(&varResult);
				DISPPARAMS disp = { NULL, NULL, 0, 0 };
				sp->Invoke(0x2, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, &varResult, NULL, NULL);
			}
		}
		return varResult.scode;
	}

	HRESULT Fire_OnUnknownSentence(BSTR Sentence)
	{
	  //Serialize access to the clients array of IConnectionPointImplMT which is accessed via GetInterfaceAt
    CComCritSecLock<CComAutoCriticalSection> lock(m_CPMTCritSec);
	
		CComVariant varResult;
		CComVariant varParam;
		int nConnections = m_Clients.GetSize();
		for (int nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
		  CComCritSecLock<CComAutoCriticalSection> lock(m_CPMTCritSec);
      CComPtr<IDispatch> sp;
      sp.Attach(GetInterfaceAt(nConnectionIndex));
			if (sp)
			{
				VariantClear(&varResult);
				varParam = Sentence;
				DISPPARAMS disp = { &varParam, NULL, 1, 0 };
				sp->Invoke(0x3, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, &varResult, NULL, NULL);
			}
		}
		return varResult.scode;
	}
};

#endif __GPSCOMCP_H__ 