#pragma once

#ifndef __GPSPORT_H__
#define __GPSPORT_H__

#include "resource.h"       // main symbols

class ATL_NO_VTABLE CGPSPort : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CGPSPort, &CLSID_GPSPort>,
	public ISupportErrorInfoImpl<&IID_IGPSPort>,
	public IDispatchImpl<IGPSPort, &IID_IGPSPort, &LIBID_GPSCOMLib>
{
public:
//Constructors / Destructors
	CGPSPort();

DECLARE_PROTECT_FINAL_CONSTRUCT()
DECLARE_REGISTRY_RESOURCEID(IDR_GPSPORT)

BEGIN_COM_MAP(CGPSPort)
	COM_INTERFACE_ENTRY(IGPSPort)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

//IGPSPort
	STDMETHOD(CreateConnection)(long Port, VARIANT_BOOL MakeNewSharable, IGPSConnection** ppGPSConnection);
	STDMETHOD(get_DataBits)(long* pVal);
	STDMETHOD(put_DataBits)(long newVal);
	STDMETHOD(get_BaudRate)(long* pVal);
	STDMETHOD(put_BaudRate)(long newVal);
	STDMETHOD(get_StopBits)(GPS_STOP_BITS* pVal);
	STDMETHOD(put_StopBits)(GPS_STOP_BITS newVal);
	STDMETHOD(get_Parity)(GPS_PARITY* pVal);
	STDMETHOD(put_Parity)(GPS_PARITY newVal);
	STDMETHOD(get_InitString)(BSTR* pVal);
	STDMETHOD(put_InitString)(BSTR newVal);

protected:
//Member variables
  long          m_nDataBits;
  long          m_nBaudRate;
  GPS_STOP_BITS m_StopBits;
  GPS_PARITY    m_Parity;
  CComBSTR      m_bstrInitString;
};

OBJECT_ENTRY_AUTO(__uuidof(GPSPort), CGPSPort)

#endif //__GPSPORT_H__
