///////////////////////// Includes ///////////////////////////////////////

#include "stdafx.h"
#include "GPSCom.h"
#include "RMCSentence.h"


///////////////////////// Macros / Defines ///////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


///////////////////////// Implementation /////////////////////////////////

CRMCSentence::CRMCSentence() : m_Date(0),
                               m_dblSpeed(0.0),
                               m_dblBearing(0.0),
                               m_nLongitude(0),
                               m_bEasting(VARIANT_TRUE),
                               m_nLatitude(0),
                               m_bNorthing(VARIANT_TRUE),
                               m_Valid(VARIANT_FALSE)
{
}

STDMETHODIMP CRMCSentence::get_Northing(VARIANT_BOOL* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_bNorthing;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Latitude(long* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_nLatitude;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Easting(VARIANT_BOOL* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_bEasting;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Longitude(long* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_nLongitude;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Bearing(double* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_dblBearing;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Speed(double* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_dblSpeed;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Date(DATE* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_Date;

	return S_OK;
}

STDMETHODIMP CRMCSentence::get_Valid(VARIANT_BOOL* pVal)
{
	//Validate our parameters
  if (pVal == NULL)
    return E_POINTER;

  *pVal = m_Valid;

	return S_OK;
}
