#pragma once

#ifndef __RMCSENTENCE_H__
#define __RMCSENTENCE_H__

#include "resource.h"       // main symbols

class ATL_NO_VTABLE CRMCSentence : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CRMCSentence, &CLSID_RMCSentence>,
	public IDispatchImpl<IRMCSentence, &IID_IRMCSentence, &LIBID_GPSCOMLib>
{
public:
//Constructors / Destructors
	CRMCSentence();

DECLARE_PROTECT_FINAL_CONSTRUCT()
DECLARE_NO_REGISTRY()

BEGIN_COM_MAP(CRMCSentence)
	COM_INTERFACE_ENTRY(IRMCSentence)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

//IRMCSentence
	STDMETHOD(get_Date)(DATE *pVal);
	STDMETHOD(get_Speed)(double* pVal);
	STDMETHOD(get_Bearing)(double* pVal);
	STDMETHOD(get_Longitude)(long* pVal);
	STDMETHOD(get_Easting)(VARIANT_BOOL* pVal);
	STDMETHOD(get_Latitude)(long* pVal);
	STDMETHOD(get_Northing)(VARIANT_BOOL* pVal);
	STDMETHOD(get_Valid)(VARIANT_BOOL *pVal);

//Member variables
  DATE         m_Date;
  double       m_dblSpeed;
  double       m_dblBearing;
  long         m_nLongitude;
  VARIANT_BOOL m_bEasting;
  long         m_nLatitude;
  VARIANT_BOOL m_bNorthing;
  VARIANT_BOOL m_Valid;
};

#endif //__RMCSENTENCE_H__
